# ͂܂łBڂreadme.doc5.2߂ĉB
#	Usage: jgawk -f dirgrep.awk expr dir1 dir2 ...
# w肳ꂽfBNg̃t@CċAIɒׂȂAet@Ĉ
# w肵K\Ƀ}b`st@CTA΂
# t@C̖OETCYE쐬ƁA}b`sSĂ\܂B
#
# gݍ݊֐tolowerȂǂgĂ邽߁Axo[W̐Vjgawk
# ȂƂƓ삵܂B
BEGIN{
	tmpcmd_name = make_tmpcmd()
	for(i = 2; i < ARGC; i++) fsearch(ARGV[1], ARGV[i])
	exit(0)
}
END{
	remove_tmpcmd(tmpcmd_name)
}

function fsearch(expr, fname,	    tmpcmd, line, info, cnt, dirname, lines, i)
{ # fnamefBNgł΂̉̃t@CċAIɒׂȂA
  # et@Cɑ΂strsearch֐Ăяo
	if(fname ~ /^([A-Za-z]:)?[\/\\]$/){ # u/v̓ʈ
		fname = fname "*.*"
	} else
	if(fname ~ /(((^|[:\/\\])\.\.?)|(^[A-Za-z]:))$/){ #u.vu..v̓ʈ
		fname = fname "/*.*"
	}
	tmpcmd = tmpcmd_name " " fname

	while((tmpcmd | getline line) > 0) lines[++cnt] = line
	close(tmpcmd)
	if(!cnt){
		printf "%s not found.\n", fname > "/dev/stderr"
		exit(1)
	}
	dirname = fname; gsub(/[^:\/\\]*$/, "", dirname)
	for(i = 1; i <= cnt; i++){
		splitinfo(lines[i], info)
		if(info["name"] ~ /^\.\.?$/) continue
		info["name"] = dirname info["name"]
		if(info["attr"] ~ /^.d/){
			fsearch(expr, info["name"] "/*.*")
		} else {
			strsearch(expr, info)
		}
	}
}

function strsearch(expr, finfo, 	fname, found)
{ # t@C̏񂪔zfinfoɗ^ĂƂÃt@Cexpr
  # ܂ލsT
	fname = tolower(finfo["name"]); gsub(/\\/, "/", fname)
	while((getline < fname) > 0){
		if($0 ~ expr){
			if(!found++){
				printf "--- %s %s%8d %s\n", finfo["date"],
				  finfo["time"], finfo["size"], fname
			}
			print
		}
	}
	close(fname)
}

function splitinfo(line, info, 	   i)
{ # t@CETCYEȂǂɕ
	info["size"] = hex_to_int(substr(line, 1, 8))
	i = hex_to_int(substr(line, 9, 4))
	info["date"] = sprintf("%02d/%02d/%02d",
		(int(i / 512) + 1980) % 100, int((i % 512) / 32), i % 32)
	i = hex_to_int(substr(line, 13, 4))
	info["time"] = sprintf("%02d:%02d:%02d",
		int(i / 2048), int((i % 2048) / 32), i % 32)
	info["attr"] = hex_to_attr(substr(line, 17, 2))
	info["name"] = substr(line, 19)
}

function hex_to_int(s,	    i)
{ # 16i̐\s𐮐ɒĕԂ
	if(!(0 in char_to_int)){
	 # ŏ1񂾂zchar_to_intȌジƎĂ
		for(i = 0; i < 10; i++)
			char_to_int[i] = i
		for(i = 10; i < 16; i++){
			char_to_int[substr("abcdef", i - 9, 1)] = i
			char_to_int[substr("ABCDEF", i - 9, 1)] = i
		}
	}
	for(i = 0; s != ""; s = substr(s, 2)){
		i *= 16; i += char_to_int[substr(s, 1, 1)]
	}
	return i
}

function hex_to_attr(s,	    n, i, c)
{ # 16i̐\s𑮐\ɒĕԂ
	n = hex_to_int(s)
	if(n % 2) s = "-"; else s = "w"
	n = int(n / 2)
	for(i = 1; i <= 5; i++){
		if(n % 2) c = substr("hsvda", i, 1); else c = "-"
		s = c s
		n = int(n / 2)
	}
	return s
}

function add_delim(dname)
{ # KvȏꍇɁu/vtĕԂ
	if(dname ~ /(^|[:\/\\])$/) return dname
	return dname "/"
}

function make_tmpcmd(	tmp_name)
{ # ꎞR}h𐶐BR}h𕶎ƂĕԂ
	tmp_name = ENVIRON["TMP"]
	if(tmp_name == "") tmp_name = ENVIRON["TEMP"]
	tmp_name = add_delim(tmp_name) "wlisttxt.com"
	printf "%s", \
		"T_OOWW3=XXWXPY50PPZ5jQP_-ys,A1Ea5y852cP4Z4PP-pV40P-BOu\n" \
		"com2txt/Nide5UqPWX,wP500-MQP4UP-wx4XP5rjP5Z2P-jC,JP=\n" \
		"5O4,APRX5BZP-pJPPQX42P-r=PRX55aP59DHHP-99,UP-lt,mP-uq=\n" \
		"P5_VHP-4A40PTZ,TPP_RX__mAjzqpOMH3n44DN4Opuu46fe4H45HWK\n" \
		"rb7MC.C8a25kFApBtSkdV4Lta2pOic.ChA4BtS6orn6PCb._hHPAK.\n" \
		"_o24wOtn6TCb.2bpGPFzBl4P6otl4whHpBpBn.04LMPTXk.lPSRzN.\n" \
		"J4H3DI45h4pAYVLL8BgLBAMdDUuLnbq9E4X.GPrzIGlTA._oG4umrI\n" \
		"eASTUJtPKkG4RzKClTAJ8j94PCMHWHPN8EuCB9GAlTAqpEZVUmXp9.\n" \
		"ASLtazMG5n4ALsRGG4P:\n" > tmp_name
	close(tmp_name)
	gsub(/\//, "\\", tmp_name) # R}hƂėp̂߁u/vu\v
	return tmp_name
}
function remove_tmpcmd(tmp_name)
{ # ꎞR}ȟЕt
	if(tmp_name != "") system("if EXIST " tmp_name " del " tmp_name)
}
